//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

// Test suite 5 - test corrupted byte buffer
// Build a byte array to send, but corrupt the checksum
// Then build a message to send and corrupt the length field - should get a checksum mismatch

#include "NXTBeeComms.h"

// default broadcast this message
#define ADDR BROADCAST

task main() {

  int len;

  eraseDisplay();
  bNxtLCDStatusDisplay = false;
  setupHighSpeedLink();

  nxtDisplayString(1, "NXTBee Corrupt Test");

  len = 10;

  for(int i=START_OF_MSG; i < START_OF_MSG + len; i++)
    transmitBuffer[i] = i;

  while(nNxtButtonPressed != kEnterButton) {

	  transmitBuffer[BYTE_COUNT] = len;
	  transmitBuffer[MSG_TYPE] = BYTE_STRING_TYPE;
	  transmitBuffer[ADDRESS] = ADDR;
    transmitBuffer[CKSUM] = 123; // some arbitrary value
    nxtWriteRawHS(transmitBuffer[0], len+HEADER_SIZE);  // should give a checksum error
    wait10Msec(50);

    // now send a valid packet
    transmitBytes(ADDR, BYTE_STRING_TYPE, len);
    wait10Msec(50);

    // now send a packet where the length field is truncated
	  transmitBuffer[BYTE_COUNT] = 0;
	  transmitBuffer[MSG_TYPE] = BYTE_STRING_TYPE;
	  transmitBuffer[ADDRESS] = ADDR;
    transmitBuffer[CKSUM] = 123; // some arbitrary value
    nxtWriteRawHS(transmitBuffer[0], len+HEADER_SIZE);  // should give a checksum error
    wait10Msec(50);

  }

}
